﻿/*
Frog Rescue - Car class
*/

#include <windows.h>
#pragma hdrstop

#include "tlib.h"

#include "CCar.h"

using namespace tlib;



CCar::CCar(double aX, double aY, double aAngle, int aType, int aSpeed)
{
	mState = csIdle;
	mX = aX;
	mY = aY;
	mAngle = aAngle;
	mType = aType;
	mSpeed = aSpeed;
}



void CCar::Move(double aX, double aY)
{
	mState = csMoving;
	mMoveCounter = 0;
	mSourceX = mX;
	mSourceY = mY;
	mDestX = aX;
	mDestY = aY;
}



void CCar::Update()
{
	switch (mState)
	{
	case csMoving:
		mMoveCounter++;
		if (mMoveCounter >= mSpeed)
		{
			mState = csIdle;
			mX = mDestX;
			mY = mDestY;
		}
		else
		{
			mX = (mDestX - mSourceX) * mMoveCounter / mSpeed + mSourceX;
			mY = (mDestY - mSourceY) * mMoveCounter / mSpeed + mSourceY;
		}
		break;
	}
}