﻿class CRoadMap;
struct SRoadNode;
class CFrog;
class CCar;

struct SRoadBlock
{
	SRoadBlock() { }
	SRoadBlock(int aX, int aY, int aAngle)
	{
		X = aX;
		Y = aY;
		Angle = aAngle;
	}
	int X;
	int Y;
	int Angle;
};

class CGameController
{
public:
	CGameController(CApplication* aOwner);

	void Update();
	void Render(LithDX::CDevice* aDevice);

	void SetMousePos(int aX, int aY);

	void CamGoesUp();

	void PlaceRoadBlock();

private:
	CApplication *mOwner;

	LithDX::CMatrix mProjectionMatrix;

	int mMouseX;
	int mMouseY;
	LithDX::CSprite *mCursorSprite;

	double mCamX;
	double mCamY;
	double mCamZ;
	const double cDefaultCamZ;

	tlib::TArray<CFrog> mFrogs;
	int mFrogStage;
	int mFrogFrame;

	LithDX::CTexture *mFrogTexture;

	INT_PTR mJumpSound;
	int mSoundCounter;
	int cSoundCounterMax;

	void GenerateRoadData();
	CRoadMap *mRoadMap;

	LithDX::CTexture *mRoadTexture[11];
	LithDX::CTexture* GetRoadTexture(SRoadNode&);

	tlib::TArray<CCar> mCars;
	int GetRandomDirection(SRoadNode& aNode);

	LithDX::CTexture *mCarTexture[3];
	INT_PTR mSplatSound;

	bool mHasRoadBlock;
	int mRoadBlockX;
	int mRoadBlockY;
	int mRoadBlockAngle;

	tlib::TArray<SRoadBlock> mRoadBlocks;

	LithDX::CTexture *mRoadBlockTexture;

	int mFrogsSaved;
	int mFrogsSplatted;

	LithDX::CSprite *mFrogSavedSprite;
	LithDX::CSprite *mFrogSplattedSprite;
};