﻿struct SRoadNode
{
	SRoadNode()
	{
		Left = false;
		Right = false;
		Top = false;
		Bottom = false;
	}

	bool Left;
	bool Right;
	bool Top;
	bool Bottom;
};

class CRoadMap
{
public:
	CRoadMap(int aXSize, int aYSize);
	~CRoadMap();

	int GetXSize() { return mXSize; }
	int GetYSize() { return mYSize; }
	SRoadNode GetData(int aX, int aY);

	SRoadNode GetRandomPos(IStuff* aStuff, int& aX, int& aY);

	void Generate(IStuff* aStuff);

private:
	SRoadNode *mData;
	int mXSize;
	int mYSize;
	void SetData(int aX, int aY, int aLeft, int aRight, int aTop, int aBottom);

	void CreateRandomRoad(IStuff* aStuff, int aMinLength, int aMaxLength);

	void AddRoadVertical(int aColumn, int aLength, int aOffset);
	void AddRoadHorizontal(int aRow, int aLength, int aOffset);
};