namespace tlib
{

template <typename A, typename T> class CQueueIndex
{
public:
	CQueueIndex() { }

	void Push(T item)
	{
		FArray.Add(item);
	}

	void Pop()
	{
		if (!FArray.get(NumItems))
			throw TException(L"Queue empty");
		FArray.Remove(0);
	}

	PROPERTY_F(Front, T&)

	PROPERTY_F(Empty, bool)

private:
	A FArray;

	T& _GetFront() const
	{
		if (!FArray.get(NumItems))
			throw TException(L"Queue empty");
		return FArray.Item(0);
	}

	bool _GetEmpty() const
	{
		return FArray.get(NumItems) == 0;
	}
};

template <typename T> class TQueue : public CQueueIndex<CArrayIndex<T>, T> { };
template <typename T> class TFastQueue : public CQueueIndex<CFastArrayIndex<T>, T> { };

}   // namespace tlib